apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: sync-image
  namespace: {{ buildns }}
spec:
  params:
  - name: dstimage
    description: Destination image URL
    type: string
  - name: dstsecret
    description: Target Secret
    type: string
    default: nonexistant
  - name: dsttlsverify
    description: Enables TLS on target registry endpoint (for push to a non-TLS registry)
    default: "true"
    type: string
  - name: srcsecret
    description: Source Secret
    type: string
    default: nonexistant
  - name: srctlsverify
    description: Enables TLS on source registry endpoint (for pull to a non-TLS registry)
    default: "true"
    type: string
  - name: srcimage
    description: Source image URL
    type: string
  results:
  - description: Digest of the image just pushed.
    name: IMAGE_DIGEST
  steps:
  - args:
    - -c
    - |
{% if (do_registry | default(False)) == False and k8s_flavor == 'openshift' %}
        SRC_TOKEN=`cat /var/run/secrets/kubernetes.io/serviceaccount/token`
        SRC_USER={{ pipeline_sa }}
{% endif %}
        dstauth=
        dstproto="--dest-tls-verify=$(params.dsttlsverify)"
        ispproto="--tls-verify=$(params.dsttlsverify)"
        srcauth=
        srcproto="--src-tls-verify=$(params.srctlsverify)"
        if test "$DST_TOKEN" -a "$DST_USER"; then
            dstauth="--dest-creds $DST_USER:$DST_TOKEN"
        fi
        if test "$SRC_TOKEN" -a "$SRC_USER"; then
            srcauth="--src-creds $SRC_USER:$SRC_TOKEN"
        fi
        if ! skopeo copy $srcproto $dstproto $srcauth $dstauth docker://$(params.srcimage) docker://$(params.dstimage); then
            echo Failed pushing image to $(params.dstimage)
            exit 1
        fi
        skopeo inspect $ispproto docker://$(params.dstimage) | awk -F '"' '/Digest/{print $(NF-1);exit;}' | tee $(results.IMAGE_DIGEST.path)
    command:
    - /bin/sh
    name: build
    env:
    - name: DST_TOKEN
      valueFrom:
        secretKeyRef:
          name: "$(params.dstsecret)"
          key: docker-token
          optional: true
    - name: DST_USER
      valueFrom:
        secretKeyRef:
          name: "$(params.dstsecret)"
          key: docker-user
          optional: true
    - name: SRC_TOKEN
      valueFrom:
        secretKeyRef:
          name: "$(params.srcsecret)"
          key: docker-token
          optional: true
    - name: SRC_USER
      valueFrom:
        secretKeyRef:
          name: "$(params.srcsecret)"
          key: docker-user
          optional: true
{% if proxy_host | default(False) %}
    - name: http_proxy
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: https_proxy
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: no_proxy
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
    - name: HTTP_PROXY
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: HTTPS_PROXY
      value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
    - name: NO_PROXY
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
    - name: http_proxy
      value: {{ squid_address }}
    - name: https_proxy
      value: {{ squid_address }}
    - name: no_proxy
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
    - name: HTTP_PROXY
      value: {{ squid_address }}
    - name: HTTPS_PROXY
      value: {{ squid_address }}
    - name: NO_PROXY
      value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ k8s_registry_ns }}.svc.{{ cluster_domain }},.{{ k8s_registry_ns }}.svc,.{{ k8s_registry_ns }},.{{ buildns }}.svc.{{ cluster_domain }},.{{ buildns }}.svc,.{{ buildns }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
    - name: http_proxy
      value: ""
    - name: https_proxy
      value: ""
    - name: no_proxy
      value: ""
    - name: HTTP_PROXY
      value: ""
    - name: HTTPS_PROXY
      value: ""
    - name: NO_PROXY
      value: ""
{% endif %}
    image: {{ tekton_skopeo_image }}
{% if tekton_uses_resources_limits | default(False) %}
    resources:
      limits:
        cpu: "{{ tekton_skopeo_cpu_limit }}"
        memory: {{ tekton_skopeo_memory_limit }}
      requests:
        cpu: "{{ tekton_skopeo_cpu_request }}"
        memory: {{ tekton_skopeo_memory_request }}
{% else %}
    resources: {}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
      privileged: true
{% endif %}
